Package org.mariadb.jdbc

## Class MariaXaResource

- java.lang.Object
- - org.mariadb.jdbc.MariaXaResource

All Implemented Interfaces:
  `XAResource`

    public class MariaXaResource
    extends Object
    implements XAResource

### Field Summary

### Fields inherited from interface javax.transaction.xa.XAResource

`TMENDRSCAN, TMFAIL, TMJOIN, TMNOFLAGS, TMONEPHASE, TMRESUME, TMSTARTRSCAN, TMSUCCESS, TMSUSPEND, XA_OK, XA_RDONLY`

### Constructor Summary

Constructors
`MariaXaResource​(MariaDbConnection connection)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`void` `commit​(Xid xid, boolean onePhase)` Commits the global transaction specified by xid.
`void` `end​(Xid xid, int flags)` Ends the work performed on behalf of a transaction branch.
`void` `forget​(Xid xid)` Tells the resource manager to forget about a heuristically completed transaction branch.
`int` `getTransactionTimeout()` Obtains the current transaction timeout value set for this XAResource instance.
`boolean` `isSameRM​(XAResource xaResource)` This method is called to determine if the resource manager instance represented by the target object is the same as the resource manager instance represented by the parameter xares.
`int` `prepare​(Xid xid)` Ask the resource manager to prepare for a transaction commit of the transaction specified in xid.
`Xid[]` `recover​(int flags)` Obtains a list of prepared transaction branches from a resource manager.
`void` `rollback​(Xid xid)` Informs the resource manager to roll back work done on behalf of a transaction branch.
`boolean` `setTransactionTimeout​(int timeout)` Sets the current transaction timeout value for this XAResource instance.
`void` `start​(Xid xid, int flags)` Starts work on behalf of a transaction branch specified in xid.
`protected static String` `xidToString​(Xid xid)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### MariaXaResource

    public MariaXaResource​(MariaDbConnection connection)

### Method Detail

#### xidToString

    protected static String xidToString​(Xid xid)

#### commit

    public void commit​(Xid xid,
                       boolean onePhase)
                throws XAException

Commits the global transaction specified by xid.

Specified by:
  `commit` in interface `XAResource`
Parameters:
  `xid` - A global transaction identifier
  `onePhase` - If true, the resource manager should use a one-phase commit protocol to commit the work done on behalf of xid.
Throws:
  `XAException` - exception

#### end

    public void end​(Xid xid,
                    int flags)
             throws XAException

Ends the work performed on behalf of a transaction branch. The resource manager disassociates the XA resource from the transaction branch specified and lets the transaction complete.

If TMSUSPEND is specified in the flags, the transaction branch is temporarily suspended in an incomplete state. The transaction context is in a suspended state and must be resumed via the start method with TMRESUME specified.

If TMFAIL is specified, the portion of work has failed. The resource manager may mark the transaction as rollback-only

If TMSUCCESS is specified, the portion of work has completed successfully.

Specified by:
  `end` in interface `XAResource`
Parameters:
  `xid` - A global transaction identifier that is the same as the identifier used previously in the start method.
  `flags` - One of TMSUCCESS, TMFAIL, or TMSUSPEND.
Throws:
  `XAException` - An error has occurred. (XAException values are XAER_RMERR, XAER_RMFAILED, XAER_NOTA, XAER_INVAL, XAER_PROTO, or XA_RB*)

#### forget

    public void forget​(Xid xid)

Tells the resource manager to forget about a heuristically completed transaction branch.

Specified by:
  `forget` in interface `XAResource`
Parameters:
  `xid` - A global transaction identifier.

#### getTransactionTimeout

    public int getTransactionTimeout()

Obtains the current transaction timeout value set for this XAResource instance. If XAResource.setTransactionTimeout was not used prior to invoking this method, the return value is the default timeout set for the resource manager; otherwise, the value used in the previous setTransactionTimeout call is returned.

Specified by:
  `getTransactionTimeout` in interface `XAResource`
Returns:
  the transaction timeout value in seconds.

#### isSameRM

    public boolean isSameRM​(XAResource xaResource)

This method is called to determine if the resource manager instance represented by the target object is the same as the resource manager instance represented by the parameter xares.

Specified by:
  `isSameRM` in interface `XAResource`
Parameters:
  `xaResource` - An XAResource object whose resource manager instance is to be compared with the target object.
Returns:
  true if it's the same RM instance; otherwise false.

#### prepare

    public int prepare​(Xid xid)
                throws XAException

Ask the resource manager to prepare for a transaction commit of the transaction specified in xid.

Specified by:
  `prepare` in interface `XAResource`
Parameters:
  `xid` - A global transaction identifier.
Returns:
  A value indicating the resource manager's vote on the outcome of the transaction.
Throws:
  `XAException` - An error has occurred. Possible exception values are: XA_RB*, XAER_RMERR, XAER_RMFAIL, XAER_NOTA, XAER_INVAL, XAER_PROTO.

#### recover

    public Xid[] recover​(int flags)
                  throws XAException

Obtains a list of prepared transaction branches from a resource manager. The transaction manager calls this method during recovery to obtain the list of transaction branches that are currently in prepared or heuristically completed states.

Specified by:
  `recover` in interface `XAResource`
Parameters:
  `flags` - One of TMSTARTRSCAN, TMENDRSCAN, TMNOFLAGS. TMNOFLAGS must be used when no other flags are set in the parameter.
Returns:
  The resource manager returns zero or more XIDs of the transaction branches.
Throws:
  `XAException` - An error has occurred. Possible values are XAER_RMERR, XAER_RMFAIL, XAER_INVAL, and XAER_PROTO.

#### rollback

    public void rollback​(Xid xid)
                  throws XAException

Informs the resource manager to roll back work done on behalf of a transaction branch.

Specified by:
  `rollback` in interface `XAResource`
Parameters:
  `xid` - A global transaction identifier.
Throws:
  `XAException` - An error has occurred.

#### setTransactionTimeout

    public boolean setTransactionTimeout​(int timeout)

Sets the current transaction timeout value for this XAResource instance. Once set, this timeout value is effective until setTransactionTimeout is invoked again with a different value. To reset the timeout value to the default value used by the resource manager, set the value to zero. If the timeout operation is performed successfully, the method returns true; otherwise false. If a resource manager does not support explicitly setting the transaction timeout value, this method returns false.

Specified by:
  `setTransactionTimeout` in interface `XAResource`
Parameters:
  `timeout` - The transaction timeout value in seconds.
Returns:
  true if the transaction timeout value is set successfully; otherwise false.

#### start

    public void start​(Xid xid,
                      int flags)
               throws XAException

Starts work on behalf of a transaction branch specified in xid. If TMJOIN is specified, the start applies to joining a transaction previously seen by the resource manager. If TMRESUME is specified, the start applies to resuming a suspended transaction specified in the parameter xid. If neither TMJOIN nor TMRESUME is specified and the transaction specified by xid has previously been seen by the resource manager, the resource manager throws the XAException exception with XAER_DUPID error code.

Specified by:
  `start` in interface `XAResource`
Parameters:
  `xid` - A global transaction identifier to be associated with the resource.
  `flags` - One of TMNOFLAGS, TMJOIN, or TMRESUME.
Throws:
  `XAException` - An error has occurred.